	TITLE	'Ultimate Driver Ver 6.0 (C) 1989 Lindley Systems'
*
*	Copyright (c) 1981, 1982, 1983,	1987, 1989
*	LINDLEY	SYSTEMS
*	4257 Berwick Place
*	Woodbridge, VA 22192
*
*	Additional files required:
*
*		LPSWITCH.ACM	Printer and Port selections
*		LPHEADER.ACM	Device driver file header
*		LPSET	.ACM		SET program support
*		LPCTRLP	.ACM	Control-P logic
*		LPDEVIO	.ACM	Device I/O
*		LPMAIN	.ACM	Driver state machine
*		LPDATA	.ACM	Global data
*		LPCODES	.ACM	Printer specific codes
*

TRUE	EQU	0
FALSE	EQU	1

	LON	IC
*	PRINTER	DRIVER WITH USER SELECTABLE FEATURES
*	V2.1  05/03/81	Pass CR	through
*	V3.0  07/13/81	Added high bit (graphics) switch,
*			LEFT, PAGE & FORM options
*	V3.1  07/26/81	Parameters settable by patch
*	V3.2  07/27/81	Initializable units
*	V3.3  07/30/81	User programmable units
*	V3.4  08/07/81	Fixed state 2 hangup INX->LXI
*	V3.5  08/12/81	Added ESC-J,K,L	processing
*	V3.6  09/06/81	Top priority for graphic count
*	V3.7  10/03/81	MX/TX-80 version, 8255 P I/O,
*			deletes	NL after FF,
*			READY entry point
*	V3.8  10/12/81	Now uses Graftrax ESC >,=
*	V3.9  12/21/81	STATE3 for ESC A,C,N
*	V4.0  12/29/81	8251 UART and Direct port I/O
*	V4.0a 01/07/82	Deleted	deletion of NL after FF
*	V4.0b 01/11/82	Page/Form fix
*	V4.1  03/03/82	Percom ZFD parallel I/O
*	V4.1a 04/17/82	Added CR to NL,	Skip CR	if NLSW
*	V4.2  06/24/82	Added CTRL-P toggle
*	V4.2a 08/25/82	Individual port	assignments
*	V4.3  08/27/82	Z89-11 parallel	interface added
*	V4.3a 09/02/82	Fix FF on close
*	V4.3b 09/12/82	Common device I/O routines
*	V4.4  11/13/82	Set Z8255 PC-0 high on open
*	V4.5  11/19/83	Added Star printer code
*	V4.6  12/29/87	Fix SET	option table, clean up printer
*			selection.
*	V5.0  02/10/89	Support	for HDOS 3.0
*	V5.1  04/14/89	Programmable macros, parameterized escape codes
*	V6.0  09/07/89	Unified all drivers to single source file set

	XTEXT	LPSWITCH
	XTEXT	LPHEADER
	XTEXT	LPSET
	CODE	-R
	DS	DVD.ENT-*
	ERRNZ	DVD.ENT-*
	CODE	+R
*
* Entry point must be at 512.
*
* DDDVD Entry Point.
*
* ENTRY (A) = Process Code
*	(BC) = Byte Count (usu.)
*	(DE) = Buffer Address (usu.)
* EXIT	'C' Clear if OK
*	'C' Set if error
*	(A) = Error code
* USES	ALL
*
DDDVD	CALL	$TBRA		ENTER PROCESSOR
	DB	DDDNS-*		READ
	DB	DDWRITE-*	WRITE
	DB	DDDNS-*		READR
	DB	DDDNS-*		OPENR
	DB	DDOPE-*		OPENW
	DB	DDDNS-*		OPENU
	DB	DDCLOSE-*	CLOSE
	DB	DDABTR-*	ABORT
	DB	DDDNS-*		MOUNT
	DB	DDLOAD-*	LOAD
	DB	DDNOP-*		READY
* HDOS 3 CALLS BELOW:
	DB	DDDNS-* 	UPDATE SET PARAMETERS
	DB	DDNOP-*		UNLOAD DRIVER
	DB	DDDNS-*		INTERRUPT
	DB	DDDNS-*		DEVICE SPECIFIC
*
*	DDDNS - Device Not Suitable for operation
*
DDDNS	MVI	A,EC.DNS	DEVICE NOT SUITABLE
ERRRET	STC
	RET
*
*	SETP - Load & set Ctrl-P operation
*
DDLOAD	CALL	SETP	(FALLS THROUGH)
*
*	DDABTR - Issue device driver Abort to request.
*	(Close file)
*
DDABTR	XRA	A	SHOW CLOSED
	STA	LPOPN
*
*	DDNOP - Ignore request.
*
DDNOP	XRA	A	SHOW NO	ERROR
	RET
*
* Initialize & Open for Write
*
DDOPE	EQU	*
	CALL	LPTINI	; Initialize printer port hardware
*
* Clear variables:
	XRA	A
	STA	HIBIT	High bit
	STA	STATE	State variable
	STA	GSTATE	Graphics State variable
	STA	NLSW	NL switch
	STA	CCCSW	CCC switch
	STA	PROGMAC Not programming macro
*
* Set variables	to 1:
	INR	A
	STA	LPOPN	LP: Open
	STA	LX	Line Counter
	STA	CX	Column Counter
*
* Get Unit #, and send initialization sequence:
	LDA	AIO.UNI	UNIT #
	CALL	MAC1	Get address of macro
	CALL	SENDMAC
	XRA	A
	RET
*
* CLOSE processing
DDCLOSE	MVI	A,CR
	CALL	OUTCHAR
	LDA	FFSW	TEST FOR FF AT CLOSE
	ORA	A
	JZ	DDABTR
	LXI	H,LX
	MVI	M,1	RESET LINE AND COLUMN
	MVI	A,FF	SEND FF	ON CLOSE
	CALL	OUTCHAR
	JMP	DDABTR	CLOSE FILE & SHOW NO ERROR
*
*
* Write Data to the Device.
*	Any given block can end in the middle of a
*	multiple character sequence - Thus, the
*	current state of operation must be preserved
*	between activations.
*
*	D,E   Data block memory location
*	B,C   Block byte count
*	(A) = Character from buffer
*
*	If an Abort is posted before the operation completes,
*	DDWRITE exits.
*
DDWRITE	EQU	*
GTCHAR	JC	DDABTR	Look for Ctrl-C	Abort
	MOV	A,C	Check if BC = 0
	ORA	B
	RZ		Done with all characters (A=0, Carry=0)
	PUSH	D
	PUSH	B
	CALL	DOCHAR	Process	one character
	POP	B
	POP	D
	INX	D	Go to next char
	DCX	B	Decrement count
	JMP	GTCHAR	Loop for each character

	XTEXT	LPCTRLP
	XTEXT	LPDEVIO
	XTEXT	LPMAIN
	XTEXT	LPDATA
	XTEXT	LPCODES

	DW	'RL'	Relocation address

	END
